package sav.example.javaz;
import java.io.IOException;

import sav.z.*;
/**
 * Example of multi-session execution. A few sessions use one
 * database, "Resource".
 */
class MultiSessionTest implements Runnable {
  public static void main(String arg[]) throws Exception {
    Session ss0 = new Session();
    ss0.z("$base Data ~");
    for (int i = 0; i < 200; ++i) {
      ss0.z("data:#");
    }
    
    MultiSessionTest ss1 = new MultiSessionTest(1, true);
    MultiSessionTest ss2 = new MultiSessionTest(2, false);
    MultiSessionTest ss3 = new MultiSessionTest(3, false);
    MultiSessionTest ss4 = new MultiSessionTest(4, false);
    MultiSessionTest ss5 = new MultiSessionTest(5, false);
//    MultiSessionTest ss6 = new MultiSessionTest("Session6", false);
//    MultiSessionTest ss7 = new MultiSessionTest("Session7", false);
//    MultiSessionTest ss8 = new MultiSessionTest("Session8", false);
//    MultiSessionTest ss9 = new MultiSessionTest("Session9", false);
    new Thread(ss1).start();
    new Thread(ss2).start();
    new Thread(ss3).start();
    new Thread(ss4).start();
    new Thread(ss5).start();
//    new Thread(ss6).start();
//    new Thread(ss7).start();
//    new Thread(ss8).start();
//    new Thread(ss9).start();
  }
  
  int num;
  boolean modify;
  MultiSessionTest(int num, boolean modify){
    super();
    this.num = num;
    this.modify = modify;
  }
  public void run() {
    try {
      Session ss = new Session();
      ss.setReportPrinter(new ConsolePrinter());
      if (modify)
        ss.modifyBase("Data");
      else
        ss.exploreBase("Data");
      System.out.println("Session " + num + " start");
      Base base = ss.base();
      for (String dnum = base.first("data"); dnum != null; dnum = base.next("data", dnum)) {
        System.out.println("Session " + num + " " + dnum);
//        if (num == 1)
          Thread.sleep(10);
      }
      ss.close();
    } catch(Exception exc) {
      exc.printStackTrace();
    }
  }
}
